import { useEffect, useLayoutEffect, useState } from "react";
import SeatLayout from "../components/top-level/seat-layout";
import { useAppContext } from "../_context";
import { useParams, useNavigate } from "react-router-dom";

export function _Seatlayout({ ...props }) {
  const { userseats, AddOrUpdateSeats, GetAllReservedSeats } = useAppContext();
  const [reservedSeat, setReservedSeat] = useState([]);
  const [selectedSeat, setSelectedSeat] = useState([]);
  const { id } = useParams();
  const [seat] = useState([
    [0, 1, 2, 3, 0, 4, 5, 6, 0],
    [7, 8, 9, 10, 0, 11, 12, 13, 14],
    [15, 16, 17, 18, 0, 19, 20, 21, 22],
    [23, 24, 25, 26, 0, 27, 28, 29, 30],
    [31, 32, 33, 34, 0, 35, 36, 37, 38],
    [39, 40, 41, 42, 0, 43, 44, 45, 46],
    [47, 48, 49, 50, 0, 51, 52, 53, 54],
    [0, 55, 56, 57, 0, 58, 59, 60, 0],
  ]);

  useLayoutEffect(() => {
    GetAllReservedSeats();
  }, []);
  useEffect(() => {
    handleReservedSeats();
  }, [userseats]);

  const handleReservedSeats = () => {
    let seatArray = [];
    const reservedSeats = userseats?.filter((e) => e.userId != id);
    reservedSeats.forEach((element) => {
      element.seats.forEach((e) => {
        seatArray = [...seatArray, e];
        setReservedSeat(seatArray);
      });
    });
    const selectedSeats = userseats?.find((e) => e.userId == id);
    const results = selectedSeats?.seats;
    setSelectedSeat(results);
  };

  return (
    <SeatLayout
      userId={id}
      seats={seat}
      selectedSeats={selectedSeat}
      reservedSeats={reservedSeat}
      onClick={AddOrUpdateSeats}
      {...props}
    />
  );
}
